/* 
AiO Screengrabber v0.81

written 2006 - 2008 by Seddi
Contact: seddi@ihad.tv / http://www.ihad.tv

This standalone binary will grab the video-picture convert it from
yuv to rgb and resize it, if neccesary, to the same size as the framebuffer or 
vice versa. For the DM7025 (Xilleon) and DM800/DM8000 (Broadcom) the video will be
grabbed directly from the decoder memory.
It also grabs the framebuffer picture in 32Bit, 16Bit or in 8Bit mode with the 
correct colortable in 8Bit mode from the main graphics memory, because the 
FBIOGETCMAP is buggy on Vulcan/Pallas boxes and didnt give you the correct color 
map.
Finally it will combine the pixmaps to one final picture by using the framebuffer
alphamap and save it as bmp, jpeg or png file. So you will get the same picture 
as you can see on your TV Screen.

There are a few command line switches, use "grab -h" to get them listed.

A special Thanx to tmbinc and ghost for the needed decoder memory information and 
the great support.

Feel free to use the code for your own projects. See LICENSE file for details.
*/

#define GRAB_VERSION "v0.81"

#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/types.h>
#include <linux/videodev.h>
#include <linux/fb.h>
#include "png.h"
#include "jpeglib.h"

#define SWAP(x,y)	{ x ^= y; y ^= x; x ^= y; }

#define RED565(x)    ((((x) >> (11 )) & 0x1f) << 3)
#define GREEN565(x)  ((((x) >> (5 )) & 0x3f) << 2)
#define BLUE565(x)   ((((x) >> (0)) & 0x1f) << 3)

void getvideo(unsigned char *video, int *xres, int *yres);
void getosd(unsigned char *osd, unsigned char *osd_alpha, int *xres, int *yres);
void smooth_resize(unsigned char *source, unsigned char *dest, int xsource, int ysource, int xdest, int ydest, int colors);
void fast_resize(unsigned char *source, unsigned char *dest, int xsource, int ysource, int xdest, int ydest, int colors);
void (*resize)(unsigned char *source, unsigned char *dest, int xsource, int ysource, int xdest, int ydest, int colors);
void combine(unsigned char *output, unsigned char *video, unsigned char *osd, unsigned char *osd_alpha, int xres, int yres);
char* upcase(char* mixedstr);

char pngfile[256]="";
unsigned char *image_data, bg_red=0, bg_green=0, bg_blue=0;
static unsigned long image_width, image_height, image_rowbytes;
static int image_channels;

void convertpng(unsigned char *video)
{
        unsigned char *src, r, g, b;
        unsigned long color, i, row;

        for (row = 0; row < image_height; ++row) {
                src = image_data + row*image_rowbytes;
                for (i = 0; i<image_width; i++) {
                        r = *src++;
                        g = *src++;
                        b = *src++;
                        color = (r << 16) | (g << 8) | b;
                        memcpy(video + (i*3)+(row*image_rowbytes), &color, 3);
                }
        }
}

int openpng(void)
{
        FILE *infile;
        int rc;

        if (!(infile = fopen(pngfile, "rb"))) {
                printf("[grab] can't open PNG file [%s]\n", pngfile);
                return(1);
        }
        if ((rc = readpng_init(infile, &image_width, &image_height)) != 0) {
                switch (rc) {
                        case 1:
                                printf("[grab] %s is not a PNG file:\n", pngfile);
                                fclose(infile);
                                return(1);
                        case 2:
                                printf("[grab] %s has bad IHDR (libpng longjmp)\n", pngfile);
                                fclose(infile);
                                return(1);
                        case 4:
                                printf("[grab] insufficient memory\n");
                                fclose(infile);
                                return(1);
                        default:
                                printf("[grab] unknown readpng_init() error\n");
                                fclose(infile);
                                return(1);
                        }
                }
                image_data = readpng_get_image(2.2 , &image_channels, &image_rowbytes);
                readpng_cleanup(0);
                fclose(infile);

                if (!image_data) {
                        printf("[grab] unable to decode PNG image\n");
                        return(1);
                }

                printf("[grab] image hight = %ld\n", image_height);
                printf("[grab] image width = %ld\n", image_width);
                printf("[grab] image channels = %d\n", image_channels);
                printf("[grab] image rowbytes = %ld\n", image_rowbytes);
                return(0);
}

int main(int argc, char **argv) {
	FILE *pipe;
	char buf[256];

	printf("[grab] AiO Screengrabber "GRAB_VERSION"\n\n");

	int xres_v,yres_v,xres_o,yres_o,xres,yres,aspect;
	int c,osd_only,video_only,use_osd_res,width,own_hight,use_png,use_jpg,jpg_quality,no_aspect,use_letterbox;

	// we use fast resize as standard now
	resize = &fast_resize;
	
	osd_only=video_only=use_osd_res=width=own_hight=use_png=use_jpg=no_aspect=use_letterbox=0;
	jpg_quality=50;
	aspect=1;
	
	unsigned char *video, *osd, *osd_alpha, *output;

	char filename[256];
	sprintf(filename,"/tmp/screenshot.bmp");
	
	// process command line
	while ((c = getopt (argc, argv, "dhj:lbnopi:r:vf:")) != -1)
	{
		switch (c)
		{
			case 'h':
			case '?':
				printf("Usage: grab [commands] [filename]\n\n");
				printf("command:\n");
				printf("-f (videofile) png video screenshot\n");
				printf("-o only grab osd (framebuffer)\n");
				printf("-v only grab video\n");
				printf("-d always use osd resolution (good for skinshots)\n");
				printf("-n dont correct 16:9 aspect ratio\n");
				printf("-r (size) resize to a fixed width, maximum: 1920\n");
				printf("-i (size) resize to a fixed hight (only with -r), maximum: 1920\n");
				printf("-l always 4:3, create letterbox if 16:9\n");
				printf("-b use bicubic picture resize (slow but smooth)\n");
				printf("-j (quality) produce jpg files instead of bmp (quality 0-100)\n");	
				printf("-p produce png files instead of bmp\n");
				printf("-h this help screen\n\n");

				printf("If no command is given the complete picture will be grabbed.\n");
				printf("If no filename is given /tmp/screenshot.[bmp/jpg/png] will be used.\n");
				return 0;
				break;
			case 'o': // OSD only
				osd_only=1;
				video_only=0;	
				break;
			case 'v': // Video only
				video_only=1;
				osd_only=0;
				break;
			case 'd': // always use OSD resolution
				use_osd_res=1;
				no_aspect=1;
				break;
			case 'r': // use given resolution
				width=atoi(optarg);
				if (width > 1920)
				{
					printf("[grab] Error: -r (size) ist limited to 1920 pixel !\n");
					return 1;
				}
				break;
			case 'i': // use given resolution
				own_hight=atoi(optarg);
				if (own_hight > 1920)
				{
					printf("[grab] Error: -i (size) ist limited to 1920 pixel !\n");
					return 1;
				}
				break;
			case 'l': // create letterbox
				use_letterbox=1;
				break;
			case 'b': // use bicubic resizing
				resize = &smooth_resize;
				break;			
			case 'p': // use png file format
				use_png=1;
				use_jpg=0;	
				sprintf(filename,"/tmp/screenshot.png");
				break;
			case 'f':
				sprintf(pngfile, "%s", optarg);
				break;
			case 'j': // use jpg file format
				use_jpg=1;
				use_png=0;
				jpg_quality=atoi(optarg);
				sprintf(filename,"/tmp/screenshot.jpg");
				break;
			case 'n':
				no_aspect=1;
				break;
		} 
	}
	if (optind < argc) // filename
		sprintf(filename,"%s",argv[optind]);

	int mallocsize=1920*1080;
	
	video = (unsigned char *)malloc(mallocsize*3);
	osd = (unsigned char *)malloc(mallocsize*3);	
	osd_alpha = (unsigned char *)malloc(mallocsize);	

	output = (unsigned char *)malloc(mallocsize*3);

	// get osd
	if (!video_only)
		getosd(osd,osd_alpha,&xres_o,&yres_o);
	
	// get video
	if (!osd_only)
		getvideo(video,&xres_v,&yres_v);
	
	pipe=popen("cat /proc/stb/vmpeg/0/aspect","r");
	while (fgets(buf,sizeof(buf),pipe))
		sscanf(buf,"%x",&aspect); 
	pclose(pipe);
	
	// resizing
 	if (video_only)
	{
		xres=xres_v;
		yres=yres_v;
	} else if (osd_only)
	{
		xres=xres_o;
		yres=yres_o;
	} else if (xres_o == xres_v && yres_o == yres_v)
	{
		xres=xres_v;
		yres=yres_v;
	} else
	{
		if (xres_v > xres_o && !use_osd_res && (width == 0 || width > xres_o))
		{
			// resize osd to video size
			printf("[grab] Resizing OSD to %d x %d ...\n",xres_v,yres_v);	
			resize(osd,output,xres_o,yres_o,xres_v,yres_v,3);
			memcpy(osd,output,xres_v*yres_v*3);
			resize(osd_alpha,output,xres_o,yres_o,xres_v,yres_v,1);
			memcpy(osd_alpha,output,xres_v*yres_v);
			xres=xres_v;
			yres=yres_v;
		} else
		{
			// resize video to osd size
			printf("[grab] Resizing Video to %d x %d ...\n",xres_o,yres_o);	
			resize(video,output,xres_v,yres_v,xres_o,yres_o,3);
			memcpy(video,output,xres_o*yres_o*3);
			xres=xres_o;
			yres=yres_o;
		}	
	}
	

	// merge video and osd if neccessary
	if (osd_only)
		memcpy(output,osd,xres*yres*3);
	else if (video_only)
		memcpy(output,video,xres*yres*3);
	else 
	{
		printf("[grab] Merge Video with Framebuffer ...\n");
		combine(output,video,osd,osd_alpha,xres,yres);
	}

	
	// resize to specific width ?
	if (width)
	{
		if (own_hight == 0)
			own_hight = yres*width/xres;
		printf("[grab] Resizing Screenshot to %d x %d ...\n",width,own_hight);
		resize(output,video,xres,yres,width,(own_hight),3);
		yres=own_hight;
		xres=width;
		memcpy(output,video,xres*yres*3);
	}
	

	// correct aspect ratio
	if (!no_aspect && aspect == 3 && ((float)xres/(float)yres)<1.5)
	{
		printf("[grab] Correct aspect ratio to 16:9 ...\n");
		resize(output,video,xres,yres,xres,yres/1.42,3);
		yres/=1.42;
		memcpy(output,video,xres*yres*3);
	}
	
	
	// use letterbox ?
	if (use_letterbox && xres*0.8 != yres && xres*0.8 <= 1080)
	{
		int yres_neu;
		yres_neu=xres*0.8;
		printf("[grab] Create letterbox %d x %d ...\n",xres,yres_neu);		
		if (yres_neu > yres)
		{
			int ofs;
			ofs=(yres_neu-yres)>>1;
			memmove(output+ofs*xres*3,output,xres*yres*3);
			memset(output,0,ofs*xres*3);
			memset(output+ofs*xres*3+xres*yres*3,0,ofs*xres*3);
		}
		yres=yres_neu;
	}
	
	
	// saving picture
	printf("[grab] Saving %s ...\n",filename);
	FILE *fd2 = fopen(filename, "wr");
	
	
	if (!use_png && !use_jpg)
	{
		// write bmp
		unsigned char hdr[14 + 40];
		int i = 0;
#define PUT32(x) hdr[i++] = ((x)&0xFF); hdr[i++] = (((x)>>8)&0xFF); hdr[i++] = (((x)>>16)&0xFF); hdr[i++] = (((x)>>24)&0xFF);
#define PUT16(x) hdr[i++] = ((x)&0xFF); hdr[i++] = (((x)>>8)&0xFF);
#define PUT8(x) hdr[i++] = ((x)&0xFF);
		PUT8('B'); PUT8('M');
		PUT32((((xres * yres) * 3 + 3) &~ 3) + 14 + 40);
		PUT16(0); PUT16(0); PUT32(14 + 40);
		PUT32(40); PUT32(xres); PUT32(yres);
		PUT16(1);
		PUT16(24);
		PUT32(0); PUT32(0); PUT32(0); PUT32(0); PUT32(0); PUT32(0);
#undef PUT32
#undef PUT16
#undef PUT8
		fwrite(hdr, 1, i, fd2);
		
		int y;
		for (y=yres-1; y>=0 ; y-=1) {
			fwrite(output+(y*xres*3),xres*3,1,fd2);
		}
	} else if (use_png)
	{	
		// write png
		png_bytep *row_pointers;
		png_structp png_ptr;
		png_infop info_ptr;
	  
		png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, (png_voidp)NULL, (png_error_ptr)NULL, (png_error_ptr)NULL);
		info_ptr = png_create_info_struct(png_ptr);
		png_init_io(png_ptr, fd2);

		row_pointers=(png_bytep*)malloc(sizeof(png_bytep)*yres);

		int y;
		for (y=0; y<yres; y++)
			row_pointers[y]=output+(y*xres*3);
		
		png_set_bgr(png_ptr);
		png_set_IHDR(png_ptr, info_ptr, xres, yres, 8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
		png_write_info(png_ptr, info_ptr);
		png_write_image(png_ptr, row_pointers);
		png_write_end(png_ptr, info_ptr);
		png_destroy_write_struct(&png_ptr, &info_ptr);
		
		free(row_pointers);
	} else 
	{
		// write jpg
		int x,y;
		for (y=0; y<yres; y++)
			for (x=0; x<xres; x++)
				SWAP(output[x*3+y*xres*3],output[x*3+y*xres*3+2]);

		struct jpeg_compress_struct cinfo;
		struct jpeg_error_mgr jerr;
		JSAMPROW row_pointer[1];	
		int row_stride;		
		cinfo.err = jpeg_std_error(&jerr);

		jpeg_create_compress(&cinfo);
		jpeg_stdio_dest(&cinfo, fd2);
		cinfo.image_width = xres; 	
		cinfo.image_height = yres;
		cinfo.input_components = 3;	
		cinfo.in_color_space = JCS_RGB;
		jpeg_set_defaults(&cinfo);
		jpeg_set_quality(&cinfo,jpg_quality, TRUE);
		jpeg_start_compress(&cinfo, TRUE);
		row_stride = xres * 3;
		while (cinfo.next_scanline < cinfo.image_height) 
		{
			row_pointer[0] = & output[cinfo.next_scanline * row_stride];
			(void) jpeg_write_scanlines(&cinfo, row_pointer, 1);
		}
		jpeg_finish_compress(&cinfo);
		jpeg_destroy_compress(&cinfo);
	}
	
	fclose(fd2);	
	
	// Thats all folks 
	printf("[grab] ... Done !\n");
	
	// clean up
	free(video);
	free(osd);
	free(osd_alpha);
	free(output);

	return 0;
}

// grabing the video picture

void getvideo(unsigned char *video, int *xres, int *yres)
{
	printf("[grab] Grabbing Video ...\n");

	if(openpng() != 0)
		exit(1);	
	convertpng(video);
	*yres=image_height;
	*xres=image_width;
}

// grabing the osd picture

void getosd(unsigned char *osd, unsigned char *osd_alpha, int *xres, int *yres)
{
	int fb,x,y,pos,pos1,pos2,ofs;
	unsigned char *lfb;
	struct fb_fix_screeninfo fix_screeninfo;
	struct fb_var_screeninfo var_screeninfo;
	
	fb=open("/dev/fb/0", O_RDWR);
	if (fb == -1)
	{
		fb=open("/dev/fb0", O_RDWR);
		if (fb == -1)
		{
			printf("[grab] Framebuffer failed\n");
			return;
		}
	}
	
	if(ioctl(fb, FBIOGET_FSCREENINFO, &fix_screeninfo) == -1)
	{
		printf("[grab] Framebuffer: <FBIOGET_FSCREENINFO failed>\n");
		return;
	}

	if(ioctl(fb, FBIOGET_VSCREENINFO, &var_screeninfo) == -1)
	{
		printf("[grab] Framebuffer: <FBIOGET_VSCREENINFO failed>\n");
		return;
	}
	
	if(!(lfb = (unsigned char*)mmap(0, fix_screeninfo.smem_len, PROT_READ | PROT_WRITE, MAP_SHARED, fb, 0)))
	{
		printf("[grab] Framebuffer: <Memmapping failed>\n");
		return;
	}
	
	if ( var_screeninfo.bits_per_pixel == 32 ) 
	{
		printf("[grab] Grabbing 32bit Framebuffer ...\n");
	
		// get 32bit framebuffer
		pos=pos1=pos2=0;
		ofs=fix_screeninfo.line_length-(var_screeninfo.xres*4);
		
		unsigned char *memory; // use additional buffer to speed up especially when using hd skins
		memory = (unsigned char *)malloc(fix_screeninfo.line_length*var_screeninfo.yres);
		memcpy(memory,lfb,fix_screeninfo.line_length*var_screeninfo.yres);
		
		for (y=0; y < var_screeninfo.yres; y+=1)
		{
			for (x=0; x < var_screeninfo.xres; x+=1)
			{
				memcpy(osd+pos1,memory+pos2,3);// bgr
				pos1+=3;
				pos2+=3;
				osd_alpha[pos++]=memory[pos2++];// tr
			}
			pos2+=ofs;
		}
		
		free(memory);
	} else if ( var_screeninfo.bits_per_pixel == 16 )
	{
		printf("[grab] Grabbing 16bit Framebuffer ...\n");
		unsigned short color;
		
		// get 16bit framebuffer
		pos=pos1=pos2=0;
		ofs=fix_screeninfo.line_length-(var_screeninfo.xres*2);		
		for (y=0; y < var_screeninfo.yres; y+=1)
		{
			for (x=0; x < var_screeninfo.xres; x+=1)
			{
				color = lfb[pos2] << 8 | lfb[pos2+1];
				pos2+=2;
				
				osd[pos1++] = BLUE565(color); // b
				osd[pos1++] = GREEN565(color); // g
				osd[pos1++] = RED565(color); // r
				osd_alpha[pos++]=0x00; // tr - there is no transparency in 16bit mode
			}
			pos2+=ofs;
		} 
	}
	close(fb);

	*xres=var_screeninfo.xres;
	*yres=var_screeninfo.yres;
	printf("[grab] ... Framebuffer-Size: %d x %d\n",*xres,*yres);
}

// bicubic pixmap resizing

void smooth_resize(unsigned char *source, unsigned char *dest, int xsource, int ysource, int xdest, int ydest, int colors)
{
	unsigned int xs,ys,xd,yd,dpixel,fx,fy;
	unsigned int c,tmp_i;
	int x,y,t,t1;
	xs=xsource; // x-resolution source
	ys=ysource; // y-resolution source
	xd=xdest; // x-resolution destination
	yd=ydest; // y-resolution destination
	
	// get x scale factor, use bitshifting to get rid of floats
	fx=((xs-1)<<16)/xd;

	// get y scale factor, use bitshifting to get rid of floats
	fy=((ys-1)<<16)/yd;

	unsigned int sx1[xd],sx2[xd],sy1,sy2;
	
	// pre calculating sx1/sx2 for faster resizing
	for (x=0; x<xd; x++) 
	{
		// first x source pixel for calculating destination pixel
		sx1[x]=(fx*x)>>16; //floor()

		// last x source pixel for calculating destination pixel
		sx2[x]=sx1[x]+(fx>>16);
		if (fx & 0x7FFF) //ceil()
			sx2[x]++;		
	}
	
	// Scale
	for (y=0; y<yd; y++) 
	{

		// first y source pixel for calculating destination pixel
		sy1=(fy*y)>>16; //floor()

		// last y source pixel for calculating destination pixel
		sy2=sy1+(fy>>16);
		if (fy & 0x7FFF) //ceil()
			sy2++;

		for (x=0; x<xd; x++) 
		{
			// we do this for every color
			for (c=0; c<colors; c++) 
			{
				// calculationg destination pixel
				tmp_i=0;
				dpixel=0;
		
				for (t1=sy1; t1<sy2; t1++) 
				{
					for (t=sx1[x]; t<=sx2[x]; t++) 
					{
						tmp_i+=(int)source[(t*colors)+c+(t1*xs*colors)];
						dpixel++;
					}
				}
				// writing calculated pixel into destination pixmap
				dest[(x*colors)+c+(y*xd*colors)]=tmp_i/dpixel;
			}
		}
	}
}

// "nearest neighbor" pixmap resizing

void fast_resize(unsigned char *source, unsigned char *dest, int xsource, int ysource, int xdest, int ydest, int colors)
{
    int x_ratio = (int)((xsource<<16)/xdest) ;
    int y_ratio = (int)((ysource<<16)/ydest) ;

    int x2, y2, c, i ,j;
    for (i=0;i<ydest;i++) {
        for (j=0;j<xdest;j++) {
            x2 = ((j*x_ratio)>>16) ;
            y2 = ((i*y_ratio)>>16) ;
            for (c=0; c<colors; c++)
				dest[((i*xdest)+j)*colors + c] = source[((y2*xsource)+x2)*colors + c] ;
        }                
    }          
}

// combining pixmaps by using an alphamap

void combine(unsigned char *output, unsigned char *video, unsigned char *osd, unsigned char *osd_alpha, int xres, int yres)
{
	int x,y,pos,pos1;
	
	pos=pos1=0;
	for (y=0; y < yres; y+=1)
	{
		for (x=0; x < xres; x+=1)
		{
			output[pos1] =  ( ( video[pos1] * ( 0xFF-osd_alpha[pos] ) ) + ( osd[pos1] * osd_alpha[pos] ) ) >>8;
			pos1++;
			output[pos1] =  ( ( video[pos1] * ( 0xFF-osd_alpha[pos] ) ) + ( osd[pos1] * osd_alpha[pos] ) ) >>8;
			pos1++;
			output[pos1] =  ( ( video[pos1] * ( 0xFF-osd_alpha[pos] ) ) + ( osd[pos1] * osd_alpha[pos] ) ) >>8;
			pos1++;
			pos++;
		}
	}
}

// helpers

char* upcase(char* mixedstr) 
{
	int j;
	for (j=0; j< strlen(mixedstr); ++j)
	{
		mixedstr[j]=toupper(mixedstr[j]);
	} 
	return mixedstr;
}
